const maxM=1000000;
      maxN=1000000;
      maxz=2000000000;

var M, N: longint;
    dt: array [0..maxM] of longint;
    fi, fo: text;
    i, j, z, firstz, lastz, max: longint;

procedure incint(i, j, delta: longint);
begin
   { writeln('Inc: ', i, ' ', j, ' ', delta); }
   if i<0 then begin
      inc(dt[i+M], delta);
      dec(dt[M], delta);
      i := 0;
      end;
   inc(dt[i], delta);
   dec(dt[j], delta);
end;

procedure add(a, b: longint);
var d, i, w: longint;
begin
   inc(a);
   if b-a < M then exit;
   { writeln('[', a, ',', b, ']'); }
   d := (b-a) div M;
   incint(0, M, d-1);
   i := b mod M;
   w := (b-a) mod M;
   incint(i-w, i+1, 1);
end;

begin
   assign(fi, 'mrkev.in');
   reset(fi);
   read(fi, M, N);
   if (M<1) or (N<1) or (M>maxM) or (N>maxN) then halt(42);
   for i := 0 to M do
      dt[i] := 0;
   firstz := 0;
   lastz := 1;
   for i := 1 to N do begin
      read(fi, z);
      if (z<=M) or (z<=lastz) or (z>maxz) then halt(43);
      if firstz=0 then
         firstz := z
      else
         add(lastz, z);
      lastz := z;
      end;
   add(lastz mod M, firstz);
   close(fi);

   assign(fo, 'mrkev.out');
   rewrite(fo);
   max := 0;
   j := 0;
   for i := 0 to M-1 do begin
      inc(j, dt[i]);
      if j>max then max:=j;
      end;
   writeln(fo, (lastz-firstz+1+M-1) div M - max);
   j := 0;
   for i := 1 to M do begin
      inc(j, dt[i mod M]);
      if j=max then write(fo, i, ' ');
      end;
   writeln(fo);
   close(fo);
end.
