const maxM=1000000;
      maxN=1000000;
      maxz=2000000000;

var M, N: longint;
    dt: array [0..maxM] of longint;
    fi, fo: text;
    i, j, z, firstz, lastz, min: longint;

procedure incint(i, j, delta: longint);
begin
   writeln('Inc: ', i, ' ', j, ' ', delta);
   if i<0 then begin
      inc(dt[i+M], delta);
      dec(dt[M], delta);
      i := 0;
      end;
   inc(dt[i], delta);
   dec(dt[j], delta);
end;

procedure add(a, b: longint);
var d, i, w: longint;
begin
   writeln('[', a, ',', b, ']');
   i := a mod M;
   w := b-a+1;
   incint(0, M, 1 + (w+M-1) div M);
   d := w mod M;
   if d=0 then d := M;
   incint(i-M+d, i+1, -1);
end;

begin
   assign(fi, 'mrkev.in');
   reset(fi);
   read(fi, M, N);
   if (M<1) or (N<1) or (M>maxM) or (N>maxN) then halt(42);
   for i := 0 to M do
      dt[i] := 0;
   firstz := 0;
   lastz := 0;
   for i := 1 to N do begin
      read(fi, z);
      if (z<=M) or (z<=lastz) or (z>maxz) then halt(43);
      if firstz=0 then firstz := z
      else if z-lastz > M then begin
         add(firstz, lastz);
	 firstz := z;
         end;
      lastz := z;
      end;
   add(firstz, lastz);
   close(fi);

   assign(fo, 'mrkev.out');
   rewrite(fo);
   min := maxz+1;
   j := 0;
   for i := 0 to M-1 do begin
      inc(j, dt[i]);
      writeln(i, ' ', dt[i], ' ', j);
      if j<min then min:=j;
      end;
   writeln(fo, min);
   j := dt[0];
   for i := 1 to M-1 do begin
      inc(j, dt[i mod M]);
      if j=min then write(fo, i, ' ');
      end;
   if dt[0]=min then write(fo, M);
   writeln(fo);
   close(fo);
end.
